# Monster Battle

# What it is
A web based game which features battles akin to pokemon or neopets with RPG elements

# What is needed

## Artwork and Monsters
Going to need to think up some good ideas for monsters as well as attack names, each monster will need to have a front and back image,  images should probably be made to be 1024 x 1024 and can be scaled down.  Will go with the standard types, maybe more or less (fire, water, leaf, electric, stone, etc.).  Going to need a way to prevent certain types of monsters from learning moves that don't make sense.  Not sure how attack and defense will work yet, speed may be a set value with each monster and can be buffed or nerfed by items or abilities, valid values for all stats would be 1-255 with opponents getting random rolls to determine what happens.  Max level is 100.  User would either opt to be battled or search a list of opponents who want to be battled.  Once a battle is started it cannot be ended until it finishes or times out.  Battles would send push notifications when it is one opponents turn, they have a set amount of time to respond before it times out and they forfeit.  Timeout can be set by the user who creates the match, longer timeouts for more leisurely battles and shorter for fast paced battles.

## Equations
Max ev is 3 distributed randomly
Leveling rate is fixed at level^3 = experience max EX. 4^3 = 64 and 3^3 = 27 meaning level 4 is xp 27-64

http://bulbapedia.bulbagarden.net/wiki/Stats

hp = ((((2 * Base) + (ev/4) + 100) * Level) / 100) + 10
Other = ((((2 * Base) + (ev/4)) * Level) / 100) + 5

http://bulbapedia.bulbagarden.net/wiki/Damage_modification#Damage_formula

damage = (( (2 * level + 10) / 250) * (attack / defense) * base + 2) * modifier
Modifier is crit chance, bonus against target type, and miss chance (* 0)

http://bulbapedia.bulbagarden.net/wiki/Experience#Gain_formula
http://www.serebii.net/games/exp.shtml

*to get current level*
(1000000 ** (1.0/3)).ceil == 100
(999999 ** (1.0/3)).ceil == 99
(65 ** (1.0/3)).ceil == 5
(64 ** (1.0/3)).ceil == 4

## Database
User: _created_
  nickname:string
  first_name:string
  last_name:string
  email:string
  experience:integer
  credits:integer
  
Monster: _created_
  name:string
  description:text
  type:references
  hp:integer
  attack:integer
  defense:integer
  special_attack:integer
  special_defense:integer
  speed:integer
  cost:integer
  
*if i want to add teams later on add a team:references here and in battle*
TamedMonster: *has and belongs to many* _created_
  user:references
  monster:references
  name:string
  experience:integer
  ev_hp:integer
  ev_attack:integer
  ev_defense:integer
  ev_special_attack:integer
  ev_special_defense:integer
  ev_speed:integer
  team_member:integer
  current_hp:integer
  skill_1:references
  skill_2:references
  skill_3:references
  skill_4:references
  
Skill: _created_
  name:string
  description:text
  type:references
  effect:references *add this!!!!!!!*
  base_effect:integer
  special:boolean
  hidden:boolean *true for item effects and skills like 'Switch'... add scope*

*Implement later for PP, have skill_1-4 reference this instead of skill, need to add pp to skill too*
TrainedSkill:
  tamed_monster:references *??? can I do this ???*
  skill:references
  current_pp:integer
  
Type: *fire, water, etc* _created_
  name:string
  description:string
  
Item:
  name:string
  description:text
  cost:integer *amount of credits to buy*
  effect:references *reference skill? check this*
  
Inventory:
  user:references
  item:references
  amount:integer
  
Battle: _created_
  starter:references? *user*
  opponent:references? *user*
  status:string
  *add a string that holds what happened the last turn?*
  starter_team_member:references
  opponent_team_member:references
  battle_turn:references
  winner:references
  
BattleTurn: _created_
  battle_id:references
  starter_skill:references
  opponent_skill:references
  starter_damage:integer *damage is positive if heal, neg if damaged... health + damage*
  opponent_damage:integer
  outcome:string
  
  
*need to add "switch" skill which is used to determine if creature should be switcher, also add skills for item effects, item effects would need 'base_healing' or something... need a hidden flag for these skills in Skill model*

*insted of base healing skill would need "modifier" (heal, damage, speed) and "modifier_amount" which shows how much to add or subtract from health or battle stat*

*private key in application.rb...*

*using devise, active_admin, pusher, raphaeljs, will_paginate, twitter bootstrap, sunspot (solr)*

*need a codex controller, would be used for search and lists everything...*

## iPhone

