/*******************
Bootstrap Layout stuff
*******************/
$('.topbar').dropdown()
$('table.sortable#storefront-table').tablesorter({
  sortList: [[1,0]],
  headers: {
    0: { sorter: false },
    10: { sorter: false }
  }
});
$('table.sortable#codex-table').tablesorter({
  sortList: [[1,0]]
});
$('#modal-monster-info').modal();

/*******************
Other stuff
*******************/
// http://railscasts.com/episodes/240-search-sort-paginate-with-ajax
$("#storefront .pagination a").live("click", function() {
  console.log(this.href);
  $.getScript(this.href);
  return false;
});

/*******************
Battle ajax
*******************/

// /battles/1/current_turn.json
var battleData;
var attackerCreatureUrl, defenderCreatureUrl;
var attackerCreatureData, defenderCreatureData; // delete
$.ajax({
  url: "/battles/" + battleRailsData.id + ".json",
  success: function(data) {
    battleData = data;
    if(battleData.role == "opponent") {
      attackerCreatureUrl = "/monsters/" + battleData.battle.opponent_team_member_id + ".json"
      defenderCreatureUrl = "/monsters/" + battleData.battle.starter_team_member_id + ".json"
    } else {
      attackerCreatureUrl = "/monsters/" + battleData.battle.starter_team_member_id + ".json"
      defenderCreatureUrl = "/monsters/" + battleData.battle.opponent_team_member_id + ".json"
    }
    
    $.ajax({
      url: attackerCreatureUrl,
      success: function(data) {
        attackerCreatureData = data;
      }
    });
    $.ajax({
      url: defenderCreatureUrl,
      success: function(data) {
        defenderCreatureData = data;
      }
    });
  }
});


function updateStatus()
{
  var attackerCreatureData, defenderCreatureData;
  $.ajax({
    url: attackerCreatureUrl,
    success: function(data) {
      attackerCreatureData = data;
      attackerData.currentHpBar.animate({width: ((attackerCreatureData.current_hp / attackerCreatureData.hp) * attackerData.hpBar.attrs.width)}, 500, "back-in", null);
      attackerData.hp.attr({text: attackerCreatureData.current_hp + " / " + attackerCreatureData.hp});
    }
  });
  $.ajax({
    url: defenderCreatureUrl,
    success: function(data) {
      defenderCreatureData = data;
      defenderData.currentHpBar.animate({width: ((defenderCreatureData.current_hp / defenderCreatureData.hp) * defenderData.hpBar.attrs.width)}, 500, "back-in", null);
      defenderData.hp.attr({text: defenderCreatureData.current_hp + " / " + defenderCreatureData.hp});
    }
  });
  /* dont think this is used anymore? */
  $('#battle-waiting').fadeOut("slow", function() {
    $.ajax({
      url: "/battles/" + battleRailsData.id + "/current_turn.json",
      success: function(data) {
        console.log(data)
        if(data.role == 'opponent') {
          if(data.battle.opponent_skill_id == null && data.battle.starter_skill_id == null) {
            //$('#battle-waiting').text('You are choosing a move - Your opponent is choosing a move');
            $('#battle-waiting').text('Make a move');
          } else if(data.battle.opponent_skill_id == null && data.battle.starter_skill_id != null) {
            //$('#battle-waiting').text('You are choosing a move - Your opponent has picked a move');
            $('#battle-waiting').text('Make a move');
          } else if(data.battle.opponent_skill_id != null && data.battle.starter_skill_id == null) {
            $('#battle-waiting').text('Waiting for opponent...');
          }
        } else {
          if(data.battle.starter_skill_id == null && data.battle.opponent_skill_id == null) {
            //$('#battle-waiting').text('You are choosing a move - Your opponent is choosing a move');
            $('#battle-waiting').text('Make a move');
          } else if(data.battle.starter_skill_id == null && data.battle.opponent_skill_id != null) {
            //$('#battle-waiting').text('You are choosing a move - Your opponent has picked a move');
            $('#battle-waiting').text('Make a move');
          } else if(data.battle.starter_skill_id != null && data.battle.opponent_skill_id == null) {
            $('#battle-waiting').text('Waiting for opponent...');
          }
        }
        $('#battle-waiting').fadeIn("slow", null);
      }
    });
  });
//here
/* moving to pusher complete tunr event
  $('#battle-status').fadeOut("slow", function() {
    $.ajax({
      url: "/battles/" + battleRailsData.id + ".json",
      success: function(data) {
        console.log(data)
        //$('#battle-status').text(data.status);
        if(data.battle_history.length > 2) {
          $('#battle-status').text(data.battle_history[1].outcome);
        }
        $('#battle-status').fadeIn("slow", null);
      }
    });
  });
  */
}


/************************
Battle drawing
*************************/
var menuFontSize = 18
var menuFontSizeMedium = 16
var menuFontSizeSmall = 12
var menuBackgroundColor = '#222'
var menuStrokeColor = '#fff'
var floatingMenuSize = {width: 210, height: 75, radius: 10};

var paper = Raphael(document.getElementById("battle-canvas"), 600, 336 + 128);

var backgroundImage = paper.image("/battle_background_grass.png", 0, 0, 600, 336);
// 25, 215, 96 * 2, 96 * 2 for png
var attacker = paper.image(attackerRailsData.image, 75, 240, 96, 96);
// 350, 75, 96 * 2, 96 * 2 for png
var defender = paper.image(defenderRailsData.image, 400, 125, 96, 96);

var mainMenuBackground = paper.rect(0, 336, 600, 128, 0);
var mainMenuData = drawOnMainMenu(mainMenuBackground, skillsRailsData); //ruby info
mainMenuBackground.attr({fill: menuBackgroundColor, stroke: menuStrokeColor, 'stroke-width': 1}); 

var attackerMenuBackground = paper.rect(375, 250, floatingMenuSize.width, floatingMenuSize.height, floatingMenuSize.radius);
var attackerData = drawOnGameMenu(attackerMenuBackground, attackerRailsData.name, attackerRailsData.level, attackerRailsData.hp); //ruby info
attackerMenuBackground.attr({fill: menuBackgroundColor, stroke: menuStrokeColor, 'stroke-width': 2});

var defenderMenuBackground = paper.rect(15, 15, floatingMenuSize.width, floatingMenuSize.height, floatingMenuSize.radius);
var defenderData = drawOnGameMenu(defenderMenuBackground, defenderRailsData.name, defenderRailsData.level, defenderRailsData.hp); //ruby info
defenderMenuBackground.attr({fill: menuBackgroundColor, stroke: menuStrokeColor, 'stroke-width': 2});

/* For the hp / monster info... */
function drawOnGameMenu(floatingMenuBackground, name, level, hp)
{
  var HPBarSize = {width: 160, height: 18};

  var nameLocation = {x: floatingMenuBackground.attrs.x + 60, y: floatingMenuBackground.attrs.y + 20};
  var levelLocation = {x: floatingMenuBackground.attrs.x + 175, y: floatingMenuBackground.attrs.y + 20};
  var HPBarLocation = {x: floatingMenuBackground.attrs.x + 25, y: floatingMenuBackground.attrs.y + 40};
  var HPTextLocation = {x: floatingMenuBackground.attrs.x + 100, y: floatingMenuBackground.attrs.y + 48};

  var nameText = paper.text(nameLocation.x, nameLocation.y, name);
  var levelText = paper.text(levelLocation.x, levelLocation.y, 'Lv ' + level);
  var HPBarRect = paper.rect(HPBarLocation.x, HPBarLocation.y, HPBarSize.width, HPBarSize.height);
  var currentHPBarRect = paper.rect(HPBarLocation.x, HPBarLocation.y, (hp.current / hp.full) * HPBarSize.width, HPBarSize.height);
  var HPText = paper.text(HPTextLocation.x, HPTextLocation.y, hp.current + ' / ' + hp.full);

  nameText.attr({fill: '#fff', 'font-size': menuFontSizeSmall});
  levelText.attr({fill: '#fff', 'font-size': menuFontSize});
  HPText.attr({fill: '#fff', 'font-size': menuFontSizeSmall});
  HPBarRect.attr({stroke: menuStrokeColor, 'stroke-width': 1});
  currentHPBarRect.attr({fill: '#008B00'});

  return {name: nameText, level: levelText, hp: HPText, hpBar: HPBarRect, currentHpBar: currentHPBarRect};
}

/* for the menu on the bottom of the screen */
function drawOnMainMenu(mainMenu, skills)
{
  var skillsMenuBackground = paper.rect(mainMenu.attrs.x + 10, mainMenu.attrs.y + 10, mainMenu.attrs.width / 3, mainMenu.attrs.height - 20, 10);
  var monsterMenuBackground = paper.rect(skillsMenuBackground.attrs.width + 20, mainMenu.attrs.y + 10, mainMenu.attrs.width / 3, mainMenu.attrs.height - 20, 10);
  var otherMenuBackground = paper.rect(skillsMenuBackground.attrs.width + monsterMenuBackground.attrs.width + 30, mainMenu.attrs.y + 10, mainMenu.attrs.width / 4 + 10, mainMenu.attrs.height - 20, 10);

  var skillsData = drawOnSkillsMenu(skillsMenuBackground, skills);

  skillsMenuBackground.attr({stroke: menuStrokeColor, 'stroke-width': 1});
  monsterMenuBackground.attr({stroke: menuStrokeColor, 'stroke-width': 1});
  otherMenuBackground.attr({stroke: menuStrokeColor, 'stroke-width': 1});

  return {skillsMenu: skillsMenuBackground, monsterMenu: monsterMenuBackground, otherMenu: otherMenuBackground, skillsMenuData: skillsData};
}

function drawOnSkillsMenu(skillsBackground, skills)
{
  var title = paper.text(skillsBackground.attrs.x + 30, skillsBackground.attrs.y + 15, 'Skills');
  var skill_1 = paper.text(skillsBackground.attrs.width * .33, skillsBackground.attrs.y + 40, skills.skill_1 ? skills.skill_1.name : '-');
  var skill_2 = paper.text(skillsBackground.attrs.width * .75, skillsBackground.attrs.y + 40, skills.skill_2 ? skills.skill_2.name : '-');
  var skill_3 = paper.text(skillsBackground.attrs.width * .33, skillsBackground.attrs.y + 80, skills.skill_3 ? skills.skill_3.name : '-');
  var skill_4 = paper.text(skillsBackground.attrs.width * .75, skillsBackground.attrs.y + 80, skills.skill_4 ? skills.skill_4.name : '-');

  skill_1.mouseup(clickedSkill);
  skill_1.skillData = skills.skill_1;
  skill_2.mouseup(clickedSkill);
  skill_2.skillData = skills.skill_2;
  skill_3.mouseup(clickedSkill);
  skill_3.skillData = skills.skill_3;
  skill_4.mouseup(clickedSkill);
  skill_4.skillData = skills.skill_4;

  title.attr({fill: '#fff', 'font-size': menuFontSizeMedium});
  skill_1.attr({fill: '#fff', 'font-size': menuFontSizeSmall});
  skill_2.attr({fill: '#fff', 'font-size': menuFontSizeSmall});
  skill_3.attr({fill: '#fff', 'font-size': menuFontSizeSmall});
  skill_4.attr({fill: '#fff', 'font-size': menuFontSizeSmall});

  return {skill_1: skill_1, skill_2: skill_2, skill_3: skill_3, skill_4: skill_4};
}

function clickedSkill(e)
{
  console.log(this.skillData)
  $.ajax({
    url: "/battles/" + battleRailsData.id + "/attack.js",
    data: "skill=" + this.skillData.id
  }).done(function( msg ) {
    //alert( "Move Subbmitted: ");
  });
}