var pusher = new Pusher('a80e6a537acb126b78b6');
var channel = pusher.subscribe('presence-battle-' + battleRailsData.id);

pusher.connection.bind('connected', function() {
  console.log('Pusher connected...');
});
pusher.connection.bind('failed', function() {
  console.log('Pusher connection failed...');
});

channel.bind('turn-over', turnOver);
channel.bind('turn-attack', turnAttack);
channel.bind('pusher:subscription_succeeded', function(users) {
  users.each(function(user) {
    //add_member(member.id, member.info);
    changeNameColor(user.id, "green");
  });
});
channel.bind('pusher:member_added', function(user) {
  changeNameColor(user.id, "green");
});
channel.bind('pusher:member_removed', function(user) {
  changeNameColor(user.id, "red");
});

function changeNameColor(userId, color) {
  if(userId == battleRailsData.starter_id) {
    $("#battle-canvas-starter-name").css("color", color);
  } else if (userId == battleRailsData.opponent_id) {
    $("#battle-canvas-opponent-name").css("color", color);
  }
}

function turnOver(battleTurn) {
  console.log(battleTurn);
  //skillClear(battleTurn, "");
  /*
  skillRemove()
  $(".battle-canvas-starter-skill").prepend("<li>Waiting...</li>");
  $(".battle-canvas-opponent-skill").prepend("<li>Waiting...</li>");
  */
  
  //updateCurrentSkill(battleTurn.attacker, battleTurn.skill);
  //updateCurrentSkill(battleTurn.defender, battleTurn.skill);
  $("#battle-canvas-starter-skills").prepend("<li>Waiting...</li>")
  $("#battle-canvas-opponent-skills").prepend("<li>Waiting...</li>")
  
  $('#battle-waiting').text("Make a move")
  $('#battle-status').fadeOut("slow", function() {
    $('#battle-status').text(battleTurn.last_turn.outcome);
    $('#battle-status').fadeIn("slow", null);
  });
  
  updateStatus(); // update the health bars after each turn
}

function turnAttack(battleTurn) {
  console.log(battleTurn);
  //skillFill(battleTurn.user, battleTurn.skill);
  //skillAdd(battleTurn.attacker, battleTurn.skill);
  updateCurrentSkill(battleTurn.attacker, battleTurn.skill);
}

function updateCurrentSkill(userId, skill) {
  if(userId == battleRailsData.starter_id) {
    $("#battle-canvas-starter-skills li").first().text(skill)
  } else if(userId == battleRailsData.opponent_id) {
    $("#battle-canvas-opponent-skills li").first().text(skill)
  }
}

function skillAdd(userId, skill) {
  if(userId == battleRailsData.starter_id) {
    $(".battle-canvas-starter-skill li").replaceWith("<li>" + skill + "</li>");
  } else if(userId == battleRailsData.opponent_id) {
    $(".battle-canvas-opponent-skill li").replaceWith("<li>" + skill + "</li>");
  }
}

function skillRemove() {
  $(".battle-canvas-starter-skill").text("");
  $(".battle-canvas-opponent-skill").text("");
}

function skillFill(userId, skill) {
  if(userId == battleRailsData.starter_id) {
    $("#battle-canvas-starter-skill").text(skill);
  } else if(userId == battleRailsData.opponent_id) {
    $("#battle-canvas-opponent-skill").text(skill);
  }
}

function skillClear() {
  $("#battle-canvas-starter-skill").text("");
  $("#battle-canvas-opponent-skill").text("");
}