class ApiController < ApplicationController
  
  def user
    if params[:email] == nil
      render :nothing => true
    else
      @user = User.find_by_email(params[:email])
      render :json => @user.as_json(:only => [:nickname], :include => {:tamed_monsters => {:only => [:id, :name]}})
    end
  end
  
  def users
    @users = User.all
    render :json => @users.as_json(:only => [:nickname, :email])
  end
  
  def monster
    if params[:name] == nil
      render :nothing => true
    else
      @monster = Monster.find_by_name(params[:name].capitalize)
      render :json => @monster.as_json(:methods => :get_image, :except => [:created_at, :id, :updated_at, :type_id])
    end
  end
  
  def monsters
    @monsters = Monster.all
    render :json => @monsters.as_json(:only => [:id, :name], :include => [:type])
  end
  
  def tamed_monster
    if params[:id] == nil
      render :nothing => true
    else
      @tamed_monster = TamedMonster.find(params[:id])
      render :json => @tamed_monster.as_json(:only => [:name], :include => {:user => {:only => [:id, :email, :nickname]}})
    end
  end
end
