class PagesController < ApplicationController
  before_filter :authenticate_user!
  before_filter :searchable, :only => [:store, :codex]
  
  def home
  end
  
  def welcome #redirect to after user joins or visits creature / battle page without having a monster
    if(current_user.tamed_monsters.count > 0)
      redirect_to root_path
    end
  end
  
  def store
    #@monsters = Monster.search(params[:search], params[:attr]).paginate(:page => params[:page], :order => :name)
    @search = Sunspot.search(Monster) do |s|
      s.keywords params[:search]
      s.paginate(:page => params[:page], :per_page => 10)
    end
    @monsters = @search.results
  end
  
  def codex
    @search = Sunspot.search(Monster, TamedMonster, User) do |s|
      s.fulltext params[:search]
      s.paginate(:page => params[:page], :per_page => 10)
    end
    
    json = []
    @search.hits.each do |hit|
      json.push({:class => humanize_class(hit.class_name), :result => hit.result})
    end
    
    respond_to do |format|
      format.html
      format.json { render :json => json }
    end
  end

  def contact
  end

end
