class UsersController < ApplicationController
  before_filter :authenticate_user!, :only => [:current]
  
  def show
    @user = User.find(params[:id])
    @user[:gravatar] = gravatar_hash(@user.email)
    
    json = @user.as_json(:only => [:id, :email, :first_name, :last_name, :experience, :credits, :nickname, :gravatar],
                         :include => {:tamed_monsters => {:only => [:id, :monster_id, :name]}},
                         :methods => [:current_team, :level, :exp_to_next_level]
                        )
    respond_to do |format|
      format.html
      format.json {render :json => json}
    end
  end

  # Current user data
  def current
    @user = User.find(current_user)
    @user[:gravatar] = gravatar_hash(@user.email)

    json = @user.as_json(:only => [:id, :email, :first_name, :last_name, :experience, :credits, :nickname, :gravatar],
                         :include => {:tamed_monsters => {:only => [:id, :monster_id, :name]}},
                         :methods => [:current_team, :level, :exp_to_next_level]
                        )
    respond_to do |format|
      format.json {render :json => json}
    end
  end
  
  # :id's Creatures
  def monsters
    #@user = User.find(:first, :conditions => [ "lower(nickname) = ?", params[:id].downcase ])
    @user = User.find(params[:id])
    respond_to do |format|
      format.json {render :json => @user.tamed_monsters}
    end
  end
end
