class Battle < ActiveRecord::Base
  belongs_to :starter, :class_name => "User"
  belongs_to :opponent, :class_name => "User"
  belongs_to :starter_team_member, :class_name => "TamedMonster"
  belongs_to :opponent_team_member, :class_name => "TamedMonster"
  belongs_to :winner, :class_name => "User"
  has_many :battle_turns
  
  scope :joinable, :conditions => ['opponent_id IS NULL'] #changed from :waiting_for_player, and then :joinable_battles
  scope :in_progress, :conditions => {:winner_id => nil}
  scope :complete, :conditions => {:winner_id => !nil}
  
end
