MonsterBattle::Application.routes.draw do
  get "pages/home"

  ActiveAdmin.routes(self)

  devise_for :admin_users, ActiveAdmin::Devise.config
  devise_for :users, :path_prefix => 'd'
  devise_scope :user do
    get "sign_in", :to => "devise/sessions#new"
    delete "sign_out", :to => "devise/sessions#destroy"
    get "register", :to => "devise/registrations#new"
    get "profile/edit", :to => "devise/registrations#edit"
  end
  
  match "profiles/current" => "users#current", :as => :current
  #match "profiles/:id/creatures" => "users#creatures", :as => :creatures
  resources :profiles, :as => :users, :controller => :users
  resources :monsters, :as => :tamed_monsters, :controller => :tamed_monsters
  resources :species, :as => :monsters, :controller => :monsters, :only => [:index, :show]
  #resources :profiles, :controller => :users
  #resources :monsters, :controller => :tamed_monsters
  #resources :species, :controller => :monsters, :only => [:index, :show]
  resources :battles
  resources :battle_turns, :only => [:show]
  get 'my_battles' => 'battles#my_battles'
  match "battles/:id/join" => "battles#join", :as => :join
  match "battles/:id/attack" => "battles#attack", :as => :attack
  match "battles/:id/current_turn" => "battles#current_turn", :as => :current_turn
  match "welcome" => "pages#welcome"
  match "store" => "pages#store"
  match "codex" => "pages#codex"
  match "contact" => "pages#contact"
  root :to => 'pages#home'
  
  post 'pusher/auth'
  
  get "api/user"
  get "api/users"
  get "api/monsters"
  get "api/monster"
  get "api/tamed_monster"

  # The priority is based upon order of creation:
  # first created -> highest priority.

  # Sample of regular route:
  #   match 'products/:id' => 'catalog#view'
  # Keep in mind you can assign values other than :controller and :action

  # Sample of named route:
  #   match 'products/:id/purchase' => 'catalog#purchase', :as => :purchase
  # This route can be invoked with purchase_url(:id => product.id)

  # Sample resource route (maps HTTP verbs to controller actions automatically):
  #   resources :products

  # Sample resource route with options:
  #   resources :products do
  #     member do
  #       get 'short'
  #       post 'toggle'
  #     end
  #
  #     collection do
  #       get 'sold'
  #     end
  #   end

  # Sample resource route with sub-resources:
  #   resources :products do
  #     resources :comments, :sales
  #     resource :seller
  #   end

  # Sample resource route with more complex sub-resources
  #   resources :products do
  #     resources :comments
  #     resources :sales do
  #       get 'recent', :on => :collection
  #     end
  #   end

  # Sample resource route within a namespace:
  #   namespace :admin do
  #     # Directs /admin/products/* to Admin::ProductsController
  #     # (app/controllers/admin/products_controller.rb)
  #     resources :products
  #   end

  # You can have the root of your site routed with "root"
  # just remember to delete public/index.html.
  # root :to => 'welcome#index'

  # See how all your routes lay out with "rake routes"

  # This is a legacy wild controller route that's not recommended for RESTful applications.
  # Note: This route will make all actions in every controller accessible via GET requests.
  # match ':controller(/:action(/:id(.:format)))'
end
