# encoding: UTF-8
# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your
# database schema. If you need to create the application database on another
# system, you should be using db:schema:load, not running all the migrations
# from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended to check this file into your version control system.

ActiveRecord::Schema.define(:version => 20111117052009) do

  create_table "active_admin_comments", :force => true do |t|
    t.integer  "resource_id",   :null => false
    t.string   "resource_type", :null => false
    t.integer  "author_id"
    t.string   "author_type"
    t.text     "body"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "namespace"
  end

  add_index "active_admin_comments", ["author_type", "author_id"], :name => "index_active_admin_comments_on_author_type_and_author_id"
  add_index "active_admin_comments", ["namespace"], :name => "index_active_admin_comments_on_namespace"
  add_index "active_admin_comments", ["resource_type", "resource_id"], :name => "index_admin_notes_on_resource_type_and_resource_id"

  create_table "admin_users", :force => true do |t|
    t.string   "email",                                 :default => "", :null => false
    t.string   "encrypted_password",     :limit => 128, :default => "", :null => false
    t.string   "reset_password_token"
    t.datetime "reset_password_sent_at"
    t.datetime "remember_created_at"
    t.integer  "sign_in_count",                         :default => 0
    t.datetime "current_sign_in_at"
    t.datetime "last_sign_in_at"
    t.string   "current_sign_in_ip"
    t.string   "last_sign_in_ip"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "admin_users", ["email"], :name => "index_admin_users_on_email", :unique => true
  add_index "admin_users", ["reset_password_token"], :name => "index_admin_users_on_reset_password_token", :unique => true

  create_table "battle_turns", :force => true do |t|
    t.integer  "battle_id"
    t.integer  "starter_skill_id"
    t.integer  "opponent_skill_id"
    t.integer  "starter_damage"
    t.integer  "opponent_damage"
    t.string   "outcome"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "battle_turns", ["battle_id"], :name => "index_battle_turns_on_battle_id"
  add_index "battle_turns", ["opponent_skill_id"], :name => "index_battle_turns_on_opponent_skill_id"
  add_index "battle_turns", ["starter_skill_id"], :name => "index_battle_turns_on_starter_skill_id"

  create_table "battles", :force => true do |t|
    t.integer  "starter_id"
    t.integer  "opponent_id"
    t.integer  "starter_team_member_id"
    t.integer  "opponent_team_member_id"
    t.integer  "winner_id"
    t.string   "status"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "battles", ["opponent_id"], :name => "index_battles_on_opponent_id"
  add_index "battles", ["opponent_team_member_id"], :name => "index_battles_on_opponent_team_member_id"
  add_index "battles", ["starter_id"], :name => "index_battles_on_starter_id"
  add_index "battles", ["starter_team_member_id"], :name => "index_battles_on_starter_team_member_id"
  add_index "battles", ["winner_id"], :name => "index_battles_on_winner_id"

  create_table "monsters", :force => true do |t|
    t.string   "name"
    t.text     "description"
    t.integer  "type_id"
    t.integer  "hp"
    t.integer  "attack"
    t.integer  "defense"
    t.integer  "special_attack"
    t.integer  "special_defense"
    t.integer  "speed"
    t.integer  "cost"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "monsters", ["type_id"], :name => "index_monsters_on_type_id"

  create_table "skills", :force => true do |t|
    t.string   "name"
    t.text     "description"
    t.integer  "type_id"
    t.integer  "base_effect"
    t.boolean  "special"
    t.boolean  "hidden"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "skills", ["type_id"], :name => "index_skills_on_type_id"

  create_table "tamed_monsters", :force => true do |t|
    t.integer  "user_id"
    t.integer  "monster_id"
    t.string   "name"
    t.integer  "experience"
    t.integer  "current_hp"
    t.integer  "team_member"
    t.integer  "skill_1_id"
    t.integer  "skill_2_id"
    t.integer  "skill_3_id"
    t.integer  "skill_4_id"
    t.integer  "ev_hp"
    t.integer  "ev_attack"
    t.integer  "ev_defense"
    t.integer  "ev_special_attack"
    t.integer  "ev_special_defense"
    t.integer  "ev_speed"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "tamed_monsters", ["monster_id"], :name => "index_tamed_monsters_on_monster_id"
  add_index "tamed_monsters", ["skill_1_id"], :name => "index_tamed_monsters_on_skill_1_id"
  add_index "tamed_monsters", ["skill_2_id"], :name => "index_tamed_monsters_on_skill_2_id"
  add_index "tamed_monsters", ["skill_3_id"], :name => "index_tamed_monsters_on_skill_3_id"
  add_index "tamed_monsters", ["skill_4_id"], :name => "index_tamed_monsters_on_skill_4_id"
  add_index "tamed_monsters", ["user_id"], :name => "index_tamed_monsters_on_user_id"

  create_table "types", :force => true do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "users", :force => true do |t|
    t.string   "email",                                 :default => "", :null => false
    t.string   "encrypted_password",     :limit => 128, :default => "", :null => false
    t.string   "reset_password_token"
    t.datetime "reset_password_sent_at"
    t.datetime "remember_created_at"
    t.integer  "sign_in_count",                         :default => 0
    t.datetime "current_sign_in_at"
    t.datetime "last_sign_in_at"
    t.string   "current_sign_in_ip"
    t.string   "last_sign_in_ip"
    t.string   "first_name"
    t.string   "last_name"
    t.integer  "experience"
    t.integer  "credits"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "nickname"
  end

  add_index "users", ["email"], :name => "index_users_on_email", :unique => true
  add_index "users", ["reset_password_token"], :name => "index_users_on_reset_password_token", :unique => true

end
