# This file should contain all the record creation needed to seed the database with its default values.
# The data can then be loaded with the rake db:seed (or created alongside the db with db:setup).
#
# Examples:
#
#   cities = City.create([{ name: 'Chicago' }, { name: 'Copenhagen' }])
#   Mayor.create(name: 'Emanuel', city: cities.first)

User.create(email: 'ash@pokemon.com', password: 'password', password_confirmation: 'password', first_name: 'Ash', last_name: 'Ketchum', nickname: 'AKetchum')
User.create(email: 'gary@pokemon.com', password: 'password', password_confirmation: 'password', first_name: 'Gary', last_name: 'Oak', nickname: 'GOak')

Type.create(name: 'Grass', description: 'Grass type...')
Type.create(name: 'Fire', description: 'Fire type...')
Type.create(name: 'Water', description: 'Water type...')
Type.create(name: 'Physical', description: 'They like to hit things...')
Type.create(name: 'Normal', description: 'Nothing special...')
Type.create(name: 'Ghost', description: 'OOoooOOOooooOo')

Monster.create(name: 'Bulbasaur', type_id: '1', description: 'Plant type', hp: '45', attack: '49', defense: '49', special_attack: '65', special_defense: '65', speed: '45', cost: '10')
Monster.create(name: 'Charmander', type_id: '2', description: 'Fire type', hp: '39', attack: '52', defense: '43', special_attack: '60', special_defense: '50', speed: '65', cost: '10')
Monster.create(name: 'Squirtle', type_id: '3', description: 'Water type', hp: '44', attack: '48', defense: '65', special_attack: '50', special_defense: '64', speed: '43', cost: '10')
Monster.create(name: 'Ivysaur', type_id: '1', description: 'When the bud on its back starts swelling, a sweet aroma wafts to indicate the flower\'s coming bloom.', hp: '60', attack: '62', defense: '63', special_attack: '80', special_defense: '80', speed: '60', cost: '10')
Monster.create(name: 'Charmeleon', type_id: '2', description: 'In the rocky mountains where Charmeleon live, their fiery tails shine at night like stars.', hp: '58', attack: '64', defense: '58', special_attack: '80', special_defense: '65', speed: '80', cost: '10')
Monster.create(name: 'Wartortle', type_id: '3', description: 'It is said to live 10,000 years. Its furry tail is popular as a symbol of longevity.', hp: '59', attack: '63', defense: '80', special_attack: '65', special_defense: '80', speed: '58', cost: '10')
Monster.create(name: 'Venusaur', type_id: '1', description: 'After a rainy day, the flower on its back smells stronger. The scent attracts others.', hp: '80', attack: '82', defense: '83', special_attack: '100', special_defense: '100', speed: '80', cost: '100')
Monster.create(name: 'Charizard', type_id: '2', description: 'It is said that Charizard\'s fire burns hotter if it has experienced harsh battles.', hp: '78', attack: '84', defense: '78', special_attack: '109', special_defense: '85', speed: '100', cost: '100')
Monster.create(name: 'Blastoise', type_id: '3', description: 'The jets of water it spouts from the rocket cannons on its shell can punch through thick steel.', hp: '79', attack: '83', defense: '100', special_attack: '85', special_defense: '105', speed: '78', cost: '100')
Monster.create(name: 'Snorlax', type_id: '4', description: 'Sleepy...', hp: '160', attack: '110', defense: '65', special_attack: '65', special_defense: '110', speed: '30', cost: '100')
Monster.create(name: 'Magikarp', type_id: '3', description: 'Seriously?', hp: '20', attack: '10', defense: '55', special_attack: '15', special_defense: '20', speed: '80', cost: '1')
Monster.create(name: 'Haunter', type_id: '6', description: 'Ghost type', hp: '45', attack: '50', defense: '45', special_attack: '115', special_defense: '55', speed: '95', cost: '75')

Skill.create(name: 'Switch', description: 'Changed monster during battle', type: '4', base_effect: '0', special: 'false', hidden: 'true')
Skill.create(name: 'Tackle', description: 'Lunge at the enemy', type: '4', base_effect: '-50', special: 'false', hidden: 'false')
Skill.create(name: 'Vine Whip', description: 'Grass whipping attack', type: '1', base_effect: '-75', special: 'true', hidden: 'false')
Skill.create(name: 'Ember', description: 'Small burning attack', type: '2', base_effect: '-40', special: 'true', hidden: 'false')

TamedMonster.create(user_id: '1', monster_id: '1', name: 'Ash\'s Bulbasaur', experience: '200000', current_hp: '100', ev_hp: '20', ev_attack: '0', ev_defense: '0', ev_special_attack: '0', ev_special_defense: '0', ev_speed: '0', skill_1_id: '2', skill_2_id: '3')
TamedMonster.create(user_id: '2', monster_id: '2', name: 'Gary\'s Charmander', experience: '200000', current_hp: '100', ev_hp: '20', ev_attack: '0', ev_defense: '0', ev_special_attack: '0', ev_special_defense: '0', ev_speed: '0', skill_1_id: '2', skill_2_id: '4')

Battle.create(starter_id: '1', opponent_id: '2', starter_team_member_id: '1', opponent_team_member_id: '2', status: 'Example Battle', winner_id: nil)

BattleTurn.create(battle_id: '1')