#import "AsyncImageView.h"
#import "MonsterBattle.h"
#import "ASIHTTPRequest.h"

@implementation AsyncImageView

- (void)downloadGravatar:(NSString *)hash
{
    NSString *stringURL = [NSString stringWithFormat:kUrlGravatar, hash];
    NSURL *url = [NSURL URLWithString:stringURL];
    ASIHTTPRequest *request = [ASIHTTPRequest requestWithURL:url];
    [request setDelegate:self];
    [request startAsynchronous];
}

- (void)downloadCreature:(NSNumber *)idx
{
    NSString *path = [[[[MonsterBattle sharedInstance] speciesCache] objectForKey:idx] objectForKey:@"get_image"];
    NSString *stringURL = [NSString stringWithFormat:@"%@%@", kUrlHost, path];
    NSURL *url = [NSURL URLWithString:stringURL];
    NSLog(@"Creature Image: %@, path: %@", url, path);
    ASIHTTPRequest *request = [ASIHTTPRequest requestWithURL:url];
    [request setDelegate:self];
    [request startAsynchronous];
}

- (void)downloadFromPath:(NSString *)path
{
    NSString *stringURL = [NSString stringWithFormat:@"%@%@", kUrlHost, path];
    NSURL *url = [NSURL URLWithString:stringURL];
    NSLog(@"downloadFromPath: Image: %@, path: %@", url, path);
    ASIHTTPRequest *request = [ASIHTTPRequest requestWithURL:url];
    [request setSecondsToCache:60*60*4]; //cache 4 hours
    [request setDelegate:self];
    [request startAsynchronous];
}

- (void)requestFinished:(ASIHTTPRequest *)request
{
    NSData *responseData = [request responseData];
    self.image = [UIImage imageWithData:responseData];
}

- (void)requestFailed:(ASIHTTPRequest *)request
{
    NSError *error = [request error];
    NSLog(@"Async Image Download Error: %@", error);
}
@end
