//
//  Battle.m
//  MonsterBattle
//
//  Created by Joshua Button on 11/28/11.
//  Copyright (c) 2011 CSU Chico. All rights reserved.
//

#import "Battle.h"
#import "MonsterBattle.h"
#import "ASIHTTPRequest.h"

@implementation Battle
@synthesize identifier, starterId, opponentId, starterTeamMemberId, opponentTeamMemberId, winnerId, status, role, history;

- (id)initWithId:(NSNumber *)ident
{
    self = [super init];
    if(self) {
        NSString *hostPath = [NSString stringWithFormat:@"%@%@", kUrlHost, kUrlPathBattle];
        NSString *stringURL = [NSString stringWithFormat:hostPath, ident];
        NSURL *url = [NSURL URLWithString:stringURL];
        
        __block ASIHTTPRequest *request = [ASIHTTPRequest requestWithURL:url];
        [request setCompletionBlock:^{
            NSData *responseData = [request responseData];
            NSDictionary *battle = [NSJSONSerialization 
                                    JSONObjectWithData:responseData
                                    options:kNilOptions 
                                    error:nil];
            NSDictionary *battleDict = [battle objectForKey:@"battle"];
            
            self.identifier            = [battleDict objectForKey:@"id"];
            self.starterId             = [battleDict objectForKey:@"starter_id"];
            self.opponentId            = [battleDict objectForKey:@"opponent_id"];
            self.starterTeamMemberId   = [battleDict objectForKey:@"starter_team_member_id"];
            self.opponentTeamMemberId  = [battleDict objectForKey:@"opponent_team_member_id"];
            self.winnerId              = [battleDict objectForKey:@"winner_id"];
            self.status                = [battleDict objectForKey:@"status"];
            self.role                  = [battle objectForKey:@"role"];
            self.history               = [battle objectForKey:@"battle_history"];
            
            [[NSNotificationCenter defaultCenter] postNotificationName:@"BattleDownloaded" object:self];
            
            NSLog(@"Downloaded battle %@", self.identifier);
        }];
        [request setFailedBlock:^{
            NSError *error = [request error];
            NSLog(@"Battle Download Error: %@", error);
        }];
        [request startAsynchronous];
    }
    return self;
}
@end
