//
//  BattleSkillViewController.m
//  MonsterBattle
//
//  Created by Joshua Button on 12/2/11.
//  Copyright (c) 2011 CSU Chico. All rights reserved.
//

#import "BattleSkillViewController.h"
#import "MonsterBattle.h"
#import "ASIHTTPRequest.h"
#import "Battle.h"
#import "Monster.h"

@implementation BattleSkillViewController
@synthesize battle, monster, skillOneButton, skillTwoButton, skillThreeButton, skillFourButton, cancelButton;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    /* its crunch time, get it wokring and refactor later */
    if([self.monster.skillOne objectForKey:@"name"]) {
        self.skillOneButton.titleLabel.text = [self.monster.skillOne objectForKey:@"name"];
    } else {
        self.skillOneButton.enabled = false;
        self.skillOneButton.titleLabel.text = @"-";
    }
    
    if([self.monster.skillTwo objectForKey:@"name"]) {
        self.skillTwoButton.titleLabel.text = [self.monster.skillTwo objectForKey:@"name"];
    } else {
        self.skillTwoButton.enabled = false;
        self.skillTwoButton.titleLabel.text = @"-";
    }
    
    if([self.monster.skillThree objectForKey:@"name"]) {
        self.skillThreeButton.titleLabel.text = [self.monster.skillThree objectForKey:@"name"];
    } else {
        self.skillThreeButton.enabled = false;
        self.skillThreeButton.titleLabel.text = @"-";
    }
    
    if([self.monster.skillFour objectForKey:@"name"]) {
        self.skillFourButton.titleLabel.text = [self.monster.skillFour objectForKey:@"name"];
    } else {
        self.skillFourButton.enabled = false;
        self.skillFourButton.titleLabel.text = @"-";
    }
}


- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (IBAction)skillPressed:(UIButton *)sender
{
    //NSURL *url = [NSURL URLWithString:@"http://localhost:3000/battles/1/attack.js?skill=2"];
    
    NSNumber *skillOneId = [self.monster.skillOne objectForKey:@"id"];
    NSNumber *skillTwoId = [self.monster.skillTwo objectForKey:@"id"];
    NSNumber *skillThreeId = [self.monster.skillThree objectForKey:@"id"];
    NSNumber *skillFourId = [self.monster.skillFour objectForKey:@"id"];
    
    NSString *hostPath = [NSString stringWithFormat:@"%@%@", kUrlHost, kUrlPathAttack];
    NSURL *url = nil;
    if(sender.tag == 1 && skillOneId) {
        NSString *stringURL = [NSString stringWithFormat:hostPath, self.battle.identifier, skillOneId];
        url = [NSURL URLWithString:stringURL];
    } else if(sender.tag == 2 && skillTwoId) {
        NSString *stringURL = [NSString stringWithFormat:hostPath, self.battle.identifier, skillTwoId];
        url = [NSURL URLWithString:stringURL];
    } else if(sender.tag == 3 && skillThreeId) {
        NSString *stringURL = [NSString stringWithFormat:hostPath, self.battle.identifier, skillTwoId];
        url = [NSURL URLWithString:stringURL];
    } else if(sender.tag == 4 && skillFourId) {
        NSString *stringURL = [NSString stringWithFormat:hostPath, self.battle.identifier, skillFourId];
        url = [NSURL URLWithString:stringURL];
    }
    
    if(url) {
        ASIHTTPRequest *request = [ASIHTTPRequest requestWithURL:url];
        [request setRequestMethod:@"GET"];
        [request startAsynchronous];
    }
    
    [self dismissModalViewControllerAnimated:YES];
}

- (IBAction)cancelButtonPressed:(UIButton *)button
{
    [self dismissModalViewControllerAnimated:YES];
}

@end
