//
//  BattleViewController.h
//  MonsterBattle
//
//  Created by Joshua Button on 11/25/11.
//  Copyright (c) 2011 CSU Chico. All rights reserved.
//

#import <UIKit/UIKit.h>

@class AsyncImageView, MonsterBattle, Monster, User, Battle;

@interface BattleViewController : UIViewController
{
    MonsterBattle  *model;
    User           *starter;
    User           *opponent;
    Monster        *starterTeamMember;
    Monster        *opponentTeamMember;
    
    Battle         *battle;
    
    NSTimer        *reloadTimer;
    
    AsyncImageView *battlefieldImageView;
    
    AsyncImageView *starterGravatarImageView;
    AsyncImageView *starterMonsterImageView;
    UIProgressView *starterMonsterHealth;
    UILabel        *starterName;
    UILabel        *starterTeamMemberName;
    
    AsyncImageView *opponentGravatarImageView;
    AsyncImageView *opponentMonsterImageView;
    UIProgressView *opponentMonsterHealth;
    UILabel        *opponentName;
    UILabel        *opponentTeamMemberName;
}
@property(nonatomic, strong) MonsterBattle *model;
@property(nonatomic, strong) User *starter;
@property(nonatomic, strong) User *opponent;
@property(nonatomic, strong) Monster *starterTeamMember;
@property(nonatomic, strong) Monster *opponentTeamMember;

@property(nonatomic, strong) Battle *battle;

@property(nonatomic, strong) NSTimer *reloadTimer;

@property(nonatomic, strong) IBOutlet AsyncImageView *battlefieldImageView;

@property(nonatomic, strong) IBOutlet AsyncImageView *starterGravatarImageView;
@property(nonatomic, strong) IBOutlet AsyncImageView *starterMonsterImageView;
@property(nonatomic, strong) IBOutlet UIProgressView *starterMonsterHealth;
@property(nonatomic, strong) IBOutlet UILabel        *starterName;
@property(nonatomic, strong) IBOutlet UILabel        *starterTeamMemberName;

@property(nonatomic, strong) IBOutlet AsyncImageView *opponentGravatarImageView;
@property(nonatomic, strong) IBOutlet AsyncImageView *opponentMonsterImageView;
@property(nonatomic, strong) IBOutlet UIProgressView *opponentMonsterHealth;
@property(nonatomic, strong) IBOutlet UILabel        *opponentName;
@property(nonatomic, strong) IBOutlet UILabel        *opponentTeamMemberName;

- (void)userDownloaded:(NSNotification *)notification;
- (void)monsterDownloaded:(NSNotification *)notification;
- (void)reloadData;
- (void)fireTimer:(NSTimer *)theTimer;
@end
