//
//  LoginViewController.m
//  MonsterBattle
//
//  Created by Joshua Button on 11/20/11.
//  Copyright (c) 2011 CSU Chico. All rights reserved.
//

#import "LoginViewController.h"
#import "MonsterBattle.h"
#import "ASIHTTPRequest.h"

@implementation LoginViewController
@synthesize usernameField, passwordField, loginButton;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (IBAction)logIn:(id)sender
{
    NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"%@%@", kUrlHost, kUrlPathCurrentUser]];
    ASIHTTPRequest *request = [ASIHTTPRequest requestWithURL:url];
    [request setAuthenticationScheme:(NSString *)kCFHTTPAuthenticationSchemeBasic];
    [request setUsername:usernameField.text];
    [request setPassword:passwordField.text];
    
    [request startSynchronous];
    NSError *error = [request error];
    if (error) {
        NSLog(@"Error: %@", error);
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Authentication Failed" message:@"Edit your info..." delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [alert show];
        [alert release];
    } else {
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        [defaults setObject:usernameField.text forKey:@"email"];
        [defaults setObject:passwordField.text forKey:@"password"];
        [defaults synchronize];
        
        [self dismissModalViewControllerAnimated:YES];
    }
}

@end
