#define kUrlHost                    @"http://localhost:3000"
#define kUrlGravatar                @"http://www.gravatar.com/avatar/%@"

#define kUrlPathSearch              @"/codex.json?search=%@"
#define kUrlPathCurrentUser         @"/profiles/current.json"
#define kUrlPathCurrentUserBattles  @"/my_battles.json"
#define kUrlPathProfile             @"/profiles/%@.json"
#define kUrlPathSpecies             @"/species/%@.json"
#define kUrlPathMonsters            @"/monsters/%@.json"
#define kUrlPathBattle              @"/battles/%@.json"

#define kUrlPathAttack              @"/battles/%@/attack.js?skill=%@"

#import <Foundation/Foundation.h>

@class ASIHTTPRequest, Battle, User, Monster, Species;

@interface MonsterBattle : NSObject
{
    NSDictionary        *currentUser;
    NSMutableDictionary *speciesCache;
    NSMutableDictionary *monsterCache;
    NSMutableDictionary *battleCache;
    NSMutableDictionary *userCache;
}
@property(nonatomic, strong) NSDictionary *currentUser;
@property(nonatomic, strong) NSMutableDictionary *speciesCache;
@property(nonatomic, strong) NSMutableDictionary *monsterCache;
@property(nonatomic, strong) NSMutableDictionary *battleCache;
@property(nonatomic, strong) NSMutableDictionary *userCache;
+ (MonsterBattle *)sharedInstance;
- (ASIHTTPRequest *)getDataSynchronouslyFromURL:(NSString *)stringURL;
- (NSError *)logInAndGetCurrentUser;
- (Species *)speciesFromCache:(NSNumber *)identifier;
- (Monster *)monsterFromCache:(NSNumber *)identifier;
- (Battle *)battleFromCache:(NSNumber *)identifier;
- (User *)userFromCache:(NSNumber *)identifier;
- (float)calculateLevelCap:(float)level;
- (float)calculateExperienceBarWithExp:(float)experience Level:(float)level;
@end
