//
//  MonsterViewController.m
//  MonsterBattle
//
//  Created by Joshua Button on 11/30/11.
//  Copyright (c) 2011 CSU Chico. All rights reserved.
//

#import "MonsterViewController.h"
#import "MonsterBattle.h"
#import "AsyncImageView.h"
#import "Monster.h"
#import "Species.h"
#import "User.h"

@implementation MonsterViewController
@synthesize model, identifier, monster, frontImageView, name, user, species, skillOne, skillTwo, skillThree, skillFour;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    self.model = [MonsterBattle sharedInstance];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(reloadData) name:@"MonsterDownloaded" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(reloadData) name:@"UserDownloaded" object:nil];
    [self reloadData];
}


- (void)viewDidUnload
{
    [super viewDidUnload];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"MonsterDownloaded" object:nil];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"UserDownloaded" object:nil];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)reloadData
{
    // Make sure we have data downloaded before trying to set it
    if(self.monster.name) {
        self.title = self.monster.name;
        self.name.text = self.monster.name;
        self.user.text = [[self.model userFromCache:self.monster.userId] nickname];
        self.species.text = self.monster.species.name;
        self.skillOne.text = [self.monster.skillOne objectForKey:@"name"];
        self.skillTwo.text = [self.monster.skillTwo objectForKey:@"name"];
        self.skillThree.text = [self.monster.skillThree objectForKey:@"name"];
        self.skillFour.text = [self.monster.skillFour objectForKey:@"name"];
        [self.frontImageView downloadFromPath:self.monster.species.frontImageViewPath];
    }
}

@end
