//
//  ProfileViewController.m
//  MonsterBattle
//
//  Created by Joshua Button on 11/20/11.
//  Copyright (c) 2011 CSU Chico. All rights reserved.
//

#import "ProfileViewController.h"
#import "MonsterBattle.h"
#import "AsyncImageView.h"
#import "CreatureTableViewController.h"

@implementation ProfileViewController
@synthesize model, user, usernameLabel, levelLabel, creditsLabel, asyncImageView, experienceBar, experienceLabel;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.model = [MonsterBattle sharedInstance];
}


- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    if(!model.currentUser) {
        NSError *error = [model logInAndGetCurrentUser];
        if(error) {
            UIStoryboard *storyboard = [UIStoryboard storyboardWithName:@"MainStoryboard" bundle:nil];
            UIViewController *loginController = [storyboard instantiateViewControllerWithIdentifier:@"Login"];
            loginController.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
            [self presentModalViewController:loginController animated:YES];
        }
        
        NSNumber *level = [model.currentUser objectForKey:@"level"];
        NSNumber *experience = [model.currentUser objectForKey:@"experience"];
        NSNumber *credits = [model.currentUser objectForKey:@"credits"];
        self.usernameLabel.text = [model.currentUser objectForKey:@"nickname"];
        self.levelLabel.text = [NSString stringWithFormat:@"%@", level];
        self.creditsLabel.text = [NSString stringWithFormat:@"%@", credits];
        [self.asyncImageView downloadGravatar:[model.currentUser objectForKey:@"gravatar"]];
        self.experienceBar.progress = [model calculateExperienceBarWithExp:[experience floatValue] Level:[level floatValue]];
        self.experienceLabel.text = [NSString stringWithFormat:@"%@ / %.0f", experience, [model calculateLevelCap:[level intValue]]];
        //self.view.hidden = false;
    }
    NSLog(@"here: %@", self.user);
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if([[segue identifier] isEqualToString:@"SelectedCurrentTeam"]) {
        CreatureTableViewController *controller = [segue destinationViewController];
        NSArray *creatures = [model.currentUser objectForKey:@"current_team"];
        [controller setCreatures:creatures];
    } else if([[segue identifier] isEqualToString:@"SelectedAllCreatures"]) {
        CreatureTableViewController *controller = [segue destinationViewController];
        NSArray *creatures = [model.currentUser objectForKey:@"tamed_monsters"];
        [controller setCreatures:creatures];
    }
}

@end
