//
//  SpeciesViewController.m
//  MonsterBattle
//
//  Created by Joshua Button on 11/30/11.
//  Copyright (c) 2011 CSU Chico. All rights reserved.
//

#import "SpeciesViewController.h"
#import "AsyncImageView.h"
#import "Species.h"

@implementation SpeciesViewController
@synthesize identifier, species, frontImageView, name, cost, description;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(reloadData) name:@"SpeciesDownloaded" object:nil];
    [self reloadData];
}


- (void)viewDidUnload
{
    [super viewDidUnload];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"SpeciesDownloaded" object:nil];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)reloadData
{
    self.title = self.species.name;
    self.name.text = self.species.name;
    self.cost.text = [self.species.cost stringValue];
    self.description.text = self.species.description;
    [self.frontImageView downloadFromPath:self.species.frontImageViewPath];
}

@end
